"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/* tslint:disable:no-console */
const chalk = require("chalk");
// TODO chalk, plugin category setter, --no-color opt
class RegLogger {
    constructor(_category = "reg-suit") {
        this._category = _category;
        this._level = "info";
    }
    setLevel(v) {
        this._level = v;
    }
    info(msg) {
        if (this._level !== "silent") {
            console.log(this._prefix + chalk.green("info ") + msg);
        }
    }
    warn(msg) {
        if (this._level !== "silent") {
            console.warn(this._prefix + chalk.bgYellow("warn ") + chalk.yellow(msg));
        }
    }
    error(obj) {
        if (this._level !== "silent") {
            if (typeof obj === "string") {
                console.error(this._prefix + chalk.red(obj));
            }
            else {
                console.error(this._prefix + obj);
            }
        }
    }
    verbose(msg) {
        if (this._level === "verbose") {
            console.log(this._prefix + chalk.green("debug ") + chalk.gray(msg));
        }
    }
    get _prefix() {
        return `[${this._category}] `;
    }
}
exports.RegLogger = RegLogger;
const regLogger = new RegLogger();
exports.default = regLogger;
